import System.IO
import Test.HUnit

import Day2Lib (processInput1, processInput2)

testCases1 =
  [ ("data/input020.txt", 15),
    ("data/input021.txt", 14264)
  ]

testCase1 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual "input test" result $ processInput1 contents
    )

testCases2 =
  [ ("data/input020.txt", 12),
    ("data/input021.txt", 12382)
  ]

testCase2 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual "input test" result $ processInput2 contents
    )

tests =
  TestList $
    [TestCase (testCase1 c) | c <- testCases1]
      ++ [TestCase (testCase2 c) | c <- testCases2]

main :: IO ()
main = do
  runTestTT tests
  return ()
