module Day3Lib
  ( score,
    --
    processInput1,
    processInput2,
  )
where

import Data.Char (isLower, ord)
import Data.List (intersect)
import Data.List.Split (chunksOf)

score c = if isLower c then ord c - ord 'a' + 1 else ord c - ord 'A' + 27

-- ###################

processInput1 = sum . (map processLine1) . lines

processLine1 r = score . head $ intersect (take ((length r) `div` 2) r) (drop ((length r) `div` 2) r)

processInput2 = sum . (map processChunk2) . (chunksOf 3) . lines

processChunk2 [a, b, c] = score . head . (intersect c) $ intersect a b
